#ifndef AG_H
#define AG_H

#include "navega.h"
#include "grafo.h"
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

#define NUM_GERACOES 50
#define TAM_IND 60
#define MAX_POP 300
#define TAM_POP (MAX_POP)

typedef struct {
	int acoes[TAM_IND];
	float fitness;
	int tam;
}Individuo;

typedef struct {
    Individuo individuos[MAX_POP];
    int tam;     
}Populacao;

void inicia(Populacao *pop, Vertice vertices[]);

void mutacao(Individuo *ind);

Individuo selecao(Populacao *pop);

Individuo cruzamento(Populacao *pop, Vertice vertices[]);

void merge(Individuo individuos[], int tam);

void mergeSort(Individuo individuos[], int tam);

Individuo melhorFitness(Populacao *pop);

Individuo executarAG(Vertice vertices[]);

void imprimirPop(Populacao *pop, Vertice vertices[]);

void copia(Individuo *ind1, Individuo *ind2);

#endif
